#ifndef GAMEOBJECTS_HPP_INCLUDED
#define GAMEOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/GameObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GameObjects
{
    public:

        static std::vector<Interactable::GameObject> GetAll();
        static std::vector<Interactable::GameObject> GetAll(const Tile& T);
        static std::vector<Interactable::GameObject> GetAll(std::int32_t ID);
        static std::vector<Interactable::GameObject> GetAll(const std::string& Name);
        static std::vector<Interactable::GameObject> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::GameObject> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::GameObject> GetAll(const std::function<bool (const Interactable::GameObject&)>& Filter);

        static Interactable::GameObject Get();
        static Interactable::GameObject Get(const Tile& T);
        static Interactable::GameObject Get(std::int32_t ID);
        static Interactable::GameObject Get(const std::string& Name);
        static Interactable::GameObject Get(const std::vector<std::int32_t>& IDs);
        static Interactable::GameObject Get(const std::vector<std::string>& Names);
        static Interactable::GameObject Get(const std::function<bool (const Interactable::GameObject&)>& Filter);
};

/** @} */

#endif // GAMEOBJECTS_HPP_INCLUDED
