#ifndef GROUNDOBJECTS_HPP_INCLUDED
#define GROUNDOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/GroundObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GroundObjects
{
    public:

        static std::vector<Interactable::GroundObject> GetAll();
        static std::vector<Interactable::GroundObject> GetAll(std::int32_t ID);
        static std::vector<Interactable::GroundObject> GetAll(const std::string& Name);
        static std::vector<Interactable::GroundObject> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::GroundObject> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::GroundObject> GetAll(const std::function<bool (const Interactable::GroundObject&)>& Filter);

        static Interactable::GroundObject Get();
        static Interactable::GroundObject Get(const Tile& T);
        static Interactable::GroundObject Get(std::int32_t ID);
        static Interactable::GroundObject Get(const std::string& Name);
        static Interactable::GroundObject Get(const std::vector<std::int32_t>& IDs);
        static Interactable::GroundObject Get(const std::vector<std::string>& Names);
        static Interactable::GroundObject Get(const std::function<bool (const Interactable::GroundObject&)>& Filter);
};

/** @} */

#endif // GROUNDOBJECTS_HPP_INCLUDED
